<template>
  <div class="dictionaryManagement-dictData-container auto-height-container" :class="{ 'fullscreen-container': isFullscreen }">
    <vab-query-form>
      <vab-query-form-top-panel>
        <el-form ref="queryRef" inline label-width="70px" :model="queryForm" @submit.prevent>
          <el-form-item label="字典名称" prop="dictType">
            <el-select v-model="queryForm.dictType" style="width: 200px">
              <el-option v-for="item in typeOptions" :key="item.dictId" :label="item.dictName" :value="item.dictType" />
            </el-select>
          </el-form-item>
          <el-form-item v-show="!fold" label="字典标签" prop="dictLabel">
            <el-input
              v-model="queryForm.dictLabel"
              clearable
              placeholder="请输入字典标签"
              style="width: 200px"
              @keyup.enter="handleQuery"
            />
          </el-form-item>
          <el-form-item v-show="!fold" label="状态" prop="status">
            <el-select v-model="queryForm.status" clearable placeholder="数据状态" style="width: 200px">
              <el-option v-for="dict in sys_normal_disable" :key="dict.value" :label="dict.label" :value="dict.value" />
            </el-select>
          </el-form-item>
          <el-form-item>
            <el-button icon="Search" :loading="listLoading" native-type="submit" type="primary" @click="handleQuery">查询</el-button>
            <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            <el-button class="hidden-xs-only" text type="primary" @click="handleFold">
              <span v-if="fold">展开</span>
              <span v-else>合并</span>
              <vab-icon class="vab-dropdown" :class="{ 'vab-dropdown-active': fold }" icon="arrow-up-s-line" />
            </el-button>
          </el-form-item>
        </el-form>
      </vab-query-form-top-panel>
      <vab-query-form-left-panel>
        <el-button icon="Plus" type="primary" @click="handleAdd">添加</el-button>
        <el-button icon="Delete" type="danger" @click="handleDelete">删除</el-button>
        <el-button icon="Upload" plain type="warning" @click="handleExport">导出</el-button>
        <el-button icon="Close" plain type="warning" @click="handleClose">关闭</el-button>
      </vab-query-form-left-panel>
      <vab-query-form-right-panel>
        <div class="custom-table-right-tools">
          <el-button @click="handleQuery">
            <vab-icon icon="refresh-line" />
          </el-button>
          <el-button @click="clickFullScreen">
            <vab-icon :icon="isFullscreen ? 'fullscreen-exit-fill' : 'fullscreen-fill'" />
          </el-button>
          <el-popover popper-class="custom-table-checkbox">
            <template #reference>
              <el-button>
                <vab-icon icon="settings-line" />
              </el-button>
            </template>
            <vab-draggable v-model="columns" :animation="600" target=".el-checkbox-group">
              <el-checkbox-group v-model="checkList">
                <el-checkbox
                  v-for="item in columns"
                  :key="item.label"
                  :disabled="item.disableCheck"
                  :label="item.label"
                  :value="item.label"
                >
                  {{ item.label }}
                </el-checkbox>
              </el-checkbox-group>
            </vab-draggable>
          </el-popover>
        </div>
      </vab-query-form-right-panel>
    </vab-query-form>

    <el-table ref="tableRef" v-loading="listLoading" border :data="list" @selection-change="setSelectRows">
      <el-table-column align="center" type="selection" width="50" />

      <el-table-column
        v-for="(item, index) in finallyColumns"
        :key="index"
        align="center"
        :fixed="item.fixed"
        :label="item.label"
        :min-width="item.minWidth || 160"
        :prop="item.prop"
        show-overflow-tooltip
        :sortable="item.sortable"
      >
        <template #default="scope">
          <span v-if="item.label === '状态'">
            <dict-tag :options="sys_normal_disable" :value="scope.row.status" />
          </span>
          <span v-else>{{ scope.row[item.prop] }}</span>
        </template>
      </el-table-column>
      <el-table-column align="center" fixed="right" label="操作" min-width="160">
        <template #default="scope">
          <el-button icon="Edit" link type="primary" @click="handleUpdate(scope.row)">修改</el-button>
          <el-button icon="Delete" link type="primary" @click="handleDelete(scope.row)">删除</el-button>
        </template>
      </el-table-column>
      <template #empty>
        <el-empty class="vab-data-empty" description="暂无数据" />
      </template>
    </el-table>
    <vab-pagination
      :current-page="queryForm.pageNum"
      :page-size="queryForm.pageSize"
      :total="total"
      @current-change="handleCurrentChange"
      @size-change="handleSizeChange"
    />

    <dictionary-data-management-edit ref="editRef" :dict-type="queryForm.dictType" @fetch-data="fetchData" />
  </div>
</template>

<script lang="ts" setup>
import type { TableInstance } from 'element-plus'
import { VueDraggable as VabDraggable } from 'vue-draggable-plus'
import { doDelete, getList } from '/@/api/dictionaryDataManagement'
import { optionselect as getDictOptionselect, getDictType } from '/@/api/dictionaryManagement'
import useDictStore from '/@/store/modules/dict'
import { useTabsStore } from '/@/store/modules/tabs'

defineOptions({
  name: 'DictData',
})

const route = useRoute()
const router = useRouter()
const tabStore = useTabsStore()
const { delVisitedRoute } = tabStore

const { proxy } = getCurrentInstance() as any
const { sys_normal_disable } = proxy.useDict('sys_normal_disable')

const { exit, enter, isFullscreen: _isFullscreen } = useFullscreen()

const isFullscreen = ref<boolean>(false)
const fold = ref<boolean>(true)
const tableRef = ref<TableInstance>()
const editRef = ref<any>(null)
const list = ref<any>([])
const listLoading = ref<boolean>(true)

const total = ref<number>(0)
const selectRows = ref<any>([])
const checkList = ref<any>([])
const queryForm = reactive<any>({
  pageNum: 1,
  pageSize: 10,
  dictType: undefined,
  dictLabel: undefined,
  status: undefined,
})
const defaultDictType = ref('')
const typeOptions = ref<any>([])

const columns = ref<any>([
  { label: '字典编码', prop: 'dictCode', minWidth: 160, checked: true },
  { label: '字典标签', prop: 'dictLabel', minWidth: 160, checked: true },
  { label: '字典键值', prop: 'dictValue', minWidth: 160, checked: true },
  { label: '字典排序', prop: 'dictSort', minWidth: 120, checked: true },
  { label: '状态', prop: 'status', minWidth: 120, checked: true },
  { label: '备注', prop: 'remark', minWidth: 160, checked: true },
  { label: '创建时间', prop: 'createTime', minWidth: 160, checked: true },
])
const finallyColumns = computed(() => columns.value.filter((item: any) => checkList.value.includes(item.label)))

watch(
  _isFullscreen,
  () => {
    if (_isFullscreen.value) isFullscreen.value = true
    else isFullscreen.value = false
  },
  { immediate: true }
)

onActivated(() => {
  tableRef.value?.doLayout()
})

onBeforeMount(() => {
  columns.value.forEach((item: any) => {
    if (item.checked) checkList.value.push(item.label)
  })
  getTypeList()
  getTypes(route.params && route.params.dictId)
})

/** 查询字典类型详细 */
function getTypes(dictId: any) {
  getDictType(dictId).then((response: any) => {
    queryForm.dictType = response.data.dictType
    defaultDictType.value = response.data.dictType
    fetchData()
  })
}

/** 查询字典类型列表 */
function getTypeList() {
  getDictOptionselect().then((response: any) => {
    typeOptions.value = response.data
  })
}

/** 点击全屏 */
const clickFullScreen = () => {
  isFullscreen.value = !isFullscreen.value
  isFullscreen.value ? enter() : exit()
}

/** 搜索条件折叠 */
const handleFold = () => {
  fold.value = !fold.value
}

/** 查询字典数据列表 */
const fetchData = async () => {
  listLoading.value = true
  const pp = Object.assign({}, queryForm)
  const { rows, total: _total } = (await getList(pp)) as any
  list.value = rows
  total.value = _total
  listLoading.value = false
}

/** 搜索按钮操作 */
function handleQuery() {
  queryForm.pageNum = 1
  fetchData()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm('queryRef')
  queryForm.dictType = defaultDictType.value
  handleQuery()
}

const handleSizeChange = (value: number) => {
  queryForm.pageNum = 1
  queryForm.pageSize = value
  fetchData()
}

const handleCurrentChange = (value: number) => {
  queryForm.pageNum = value
  fetchData()
}

const setSelectRows = (value: string) => {
  selectRows.value = value
}

/** 新增按钮操作 */
const handleAdd = () => {
  editRef.value.showEdit()
}

/** 修改按钮操作 */
function handleUpdate(row: any) {
  editRef.value.showEdit(row)
}

/** 删除按钮操作 */
const handleDelete = (row: any = {}) => {
  if (row.dictCode) {
    $baseConfirm(`您确定要删除字典标签为“${row.dictLabel}”的数据项吗`, null, async () => {
      const { msg }: any = await doDelete(row.dictCode)
      $baseMessage(msg, 'success', 'hey')
      await fetchData()
    })
  } else {
    if (selectRows.value.length > 0) {
      const ids = selectRows.value.map((item: { dictCode: any }) => item.dictCode)
      $baseConfirm('您确定要删除选中项吗', null, async () => {
        const { msg }: any = await doDelete(ids)
        $baseMessage(msg, 'success', 'hey')
        await fetchData()
        useDictStore().removeDict(queryForm.dictType)
      })
    } else {
      $baseMessage('您未选中任何行', 'warning', 'hey')
    }
  }
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download(
    'system/dict/data/export',
    {
      ...queryForm,
    },
    `dict_data_${Date.now()}.xlsx`
  )
}

/** 关闭按钮操作 */
async function handleClose() {
  await delVisitedRoute(route.path)
  router.push({ name: 'DictionaryManagement' })
}
</script>
